<!--  TABLE  -->
<div class="flexbox-column protein-table">

  <div style="display: flex; display: flex; justify-content: space-between">
    <mat-form-field style="width: 20%">
      <input matInput (keyup)="applyFilter()" placeholder="Filter" [(ngModel)]="filterString">
    </mat-form-field>
  </div>

  <!-- MAIN-CONTENT -->
  <div style="overflow-y: auto; height: 100%" class="table-border">
    <table mat-table style="width: 100%" [dataSource]="this.subgroupDataSource" multiTemplateDataRows matSort matSortActive="proteinGroupID" matSortDirection="asc" (matSortChange)="sortTableData($event)">

      <ng-container matColumnDef="proteinGroupId"  >
        <th class = "mat-column-proteinGroupID" mat-header-cell *matHeaderCellDef mat-sort-header>Protein Subgroup ID</th>
        <td class = "mat-column-proteinGroupID" mat-cell *matCellDef="let row">{{row.proteinSubgroupId}}</td>
      </ng-container>

      @for (column of quantificationColumns; track column) {
        <ng-container [matColumnDef]="column.expID" >
          <th mat-header-cell *matHeaderCellDef mat-sort-header>Quantification</th>
          <td mat-cell *matCellDef="let row">{{row.quantifications[column.index]}}</td>
        </ng-container>
      }

      <ng-container matColumnDef="representativeAccession">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>Accession</th>
        <td mat-cell *matCellDef="let row">{{row.representativeAccession.accession}}</td>
      </ng-container>

      <ng-container matColumnDef="representativeDescription">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>Description</th>
        <td mat-cell *matCellDef="let row">{{row.representativeDescription.description}}</td>
      </ng-container>

      <ng-container matColumnDef="checkbox">
        <th mat-header-cell *matHeaderCellDef>
          <div style="display:flex;flex-direction: column;">
            <div style="display:flex;justify-content: center;gap: 2px;">
              <button class="btn btn-outline-secondary protein-table-visibility-button" matTooltip="Disable selected groups"
                (click)="disableSelectedGroups()"><mat-icon style="transform:scale(0.7) translate(-0.7em,-0.7em)">visibility_off</mat-icon></button>
              <button class="btn btn-outline-secondary protein-table-visibility-button" matTooltip="Enable selected groups"
                (click)="enableSelectedGroups()"><mat-icon style="transform:scale(0.7) translate(-0.7em,-0.7em)">visibility</mat-icon></button>
            </div>
            <mat-checkbox [(ngModel)]="selectedAll" (change)="onSelectAllGroups()"></mat-checkbox>
          </div>
        </th>
        <td mat-cell *matCellDef="let row">
          <mat-checkbox [(ngModel)]="row.isSelected"></mat-checkbox>
        </td>
      </ng-container>

      <tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></tr>
      <!-- <tr mat-row *matRowDef="let row; columns: displayedColumns;" (click)="onClick(row)" [hidden]="groupSelection === GroupSelection.MAINGROUPS && -->
      <tr mat-row *matRowDef="let row; columns: displayedColumns;" (click)="onClick(row)"
             class="group-row" [ngClass]="{
               'table-highlight-row': row.isHighlighted,
               'table-element-row': row.isDisplayed,
               'table-disabled-row': !row.isDisplayed,
               'checkbox-selected': row.isSelected,
               }">
      </tr>
    </table>
  </div>

  <!-- PAGINATOR AND PAGE-SIZE -->
  <div style="display:flex;flex-direction: row; justify-content: space-between; width: 100%; align-items: center; ">
    <div>
      <button mat-raised-button color="accent" (click)="downloadSubgroupProteinTable()">Export</button>
    </div>
    <mat-paginator #paginator style="background: none;" [pageSizeOptions]="[5,10,25,100]" showFirstLastButtons></mat-paginator>
  </div>
</div>

<!-- PROTEINGROUP-DETAILS -->
<ng-container *ngIf="this.highlightedSubgroup !== null">
  <div class="flexbox-column">
    <cdk-accordion>
      <cdk-accordion-item [expanded]="false" #accordionItem="cdkAccordionItem" role="button" tabindex="0"
        [attr.id]="'accordion-header'" [attr.aria-expanded]="accordionItem.expanded"
        [attr.aria-controls]="'accordion-body'" class="details-accordion-item">
        <!-- OPTIONS / CLICKABLE-BAR -->
        <div (click)="accordionItem.toggle()" class="details-accordion-item-header">
          <p class="details-accordion-item-header-text">
            <span class="click-hint">
              {{ accordionItem.expanded ? '🔼' : '🔽' }} Press here for details:
            </span>
            Subgroup {{ accordionItem.expanded ? "displaying group " : "show details for group " }}
            {{ this.highlightedSubgroup.proteinSubgroupId }}
          </p>
        </div>

        <!-- CONTENT -->
        <!-- <ng-container *ngIf="showDetails"> -->
          <div class="details-accordion-item-body" role="region" [style.display]="accordionItem.expanded ? '' : 'none'"
            [attr.id]="'accordion-body'" [attr.aria-labelledby]="'accordion-header'">
            <app-proteingroup-detail-view class="detail-table"
              style="min-height: 0; min-width: 0; display: flex; flex-direction: column">
            </app-proteingroup-detail-view>
          </div>
        <!-- </ng-container> -->

      </cdk-accordion-item>
    </cdk-accordion>
</div>
</ng-container>
